//====================================================================
// File Name : interrupter.c
// Function  : S3C6410 interrupe handler
//  жϴô
//
// Author :Andrew Huang <bluedrum@163.com>
//====================================================================


#include "interrupt.h"
#include "s3c6410_addr.h"
#include "utils.h"

void INTC_Init(void) 
{
  //رж
  rVIC0INTENCLEAR = 0xffffffff; 
  rVIC1INTENCLEAR = 0xffffffff; 
  
  //
  rVIC0INTSELECT = 0x0;
  rVIC1INTSELECT = 0x0;
  
  INTC_ClearVectAddr();
  
}

//ĳһж

int INTC_Enable(unsigned int intNum)
{
    if(intNum > INT_LIMIT)
     {
        return -1;
     }
     
	

	if(intNum<32)
	{
		
		rVIC0INTENABLE |= (1<<intNum);
		
	}
	else
	{
	    rVIC1INTENABLE |= (1<<(intNum -32));	    			
	}

	return 0;

}

//رĳһж

int INTC_Disable(unsigned int intNum)
{
    if(intNum > INT_LIMIT)
     {
        return -1;
     }
     
	

	if(intNum<32)
	{
		
		rVIC0INTENCLEAR |= (1<<intNum);
		
	}
	else
	{
	    rVIC1INTENCLEAR |= (1<<(intNum - 32));	    			
	}

	return 0;

}

//ĳһжΪж
int INTC_SetFIQ(unsigned int intNum)
{
    if(intNum > INT_LIMIT)
     {
        return -1;
     }
     
	

	if(intNum<32)
	{
		
		rVIC0INTSELECT |= (1<<intNum);
		
	}
	else
	{
	    rVIC1INTSELECT |= (1<<(intNum - 32));	    			
	}

	return 0;
}


/*
ȡǰжźŵжϵַ
*/

int INTC_ReadIntSrc(void)
{
  return rVIC0ADDR;
}

/*
жָʾ,ֹһжϷ
*/
void INTC_ClearVectAddr(void)
{
   rVIC0ADDR = 0x0;
   rVIC1ADDR = 0x0;
}




void INTC_SetIntISR(unsigned int intNum, void (*isr)(void) __irq)
{
  if(intNum > INT_LIMIT)
     {
        return ;
     }
     
     if(intNum < 32)
     {
         VIC0VECTADDR[intNum] = (unsigned )isr;
        
     }
     else
     {
         VIC1VECTADDR[intNum-32] = (unsigned )isr;
     }
}


//õ0ⲿжϽ
//uEINT_No: EINT No. жϽ 0-27
//					uINTType: Select EINT Type.жź 
//								Low, High, Falling, Rising, Both
//					uFltType :  Select Filter Type  ˲
//								DisFLT(Disable Filter), DLYFLT(Delay Filter), DIGFLT(Digital Filter)
//					uFltWidth : Digital Filter Width ( 1~0x3F) ˲
//

//uEINT_No <= 15 ;                   //GPN0-GPN15
//uEINT_No >= 16 && uEINT_No <= 22  //GPL8-GPL14 
//uEINT_No >= 23 && uEINT_No <= 27  //GPM0-GPM4 
int EINT_Group0_SetGPIO(unsigned int uEINT_No , INT_eTYPE uIntType, FLT_eTYPE eFltType,   unsigned int uFltWidth)
{
   unsigned int uOffset,uConValue;
   
   //ж
   // rEINT0CONx жϲ,ÿжϽŹһ.ÿռ3+1 bit
   if( uEINT_No <= 15)
   { 
      //rEINT0CON0  
      uOffset = uEINT_No >> 1 ; //2EINT0CON0ƫ
      
      uConValue = rEINT0CON0;
      
      //4λ,ȻΪӦж
      uConValue =  (uConValue & ~(0xF<<(uOffset*4))) | (uIntType<<(uOffset*4));
      
      rEINT0CON0 = uConValue;
      
      
   }
   else if(uEINT_No >= 16 && uEINT_No <= 27)
   {
      uOffset = (uEINT_No - 16) >> 1 ;
      
      uConValue = rEINT0CON1;
      
      uConValue =  (uConValue & ~(0xF<<(uOffset*4))) | (uIntType<<(uOffset*4));
       
      rEINT0CON1 = uConValue;
   }
   
   //GPIOΪӦжϽ
   
   if( uEINT_No <= 15)
   {//GPN0 - GPN15
    //10 = Ext. Interrupt[n]  = 0x2 
    uOffset = uEINT_No ;
    
    uConValue =  rGPNCON;
    
    uConValue =  (uConValue & ~(0x3<<(uOffset*2))) | (0x2<<(uOffset*2));
    
    rGPNCON = uConValue;
    
   
    
   }
   else if(uEINT_No >= 16 && uEINT_No <= 22)
   {//GPL8-GPL14
     //0011 = Ext. Interrupt[n]  = 0x3
     uOffset = uEINT_No -16;
     
     uConValue = rGPLCON1 ;
     
     uConValue =  (uConValue & ~(0xF<<(uOffset*4))) | (0x3<<(uOffset*4));
     
     rGPLCON1 = uConValue;
     
     
     
   }
   else if(uEINT_No >=23 && uEINT_No <=27)
   {  //GPM0-GPM4
      // 0011 = Ext. Interrupt[n] = 0x3 
      uOffset = uEINT_No -23;
      
      uConValue = rGPMCON ;      
      
      //öӦΪⲿж
      uConValue =  (uConValue & ~(0xF<<(uOffset*4))) | (0x3<<(uOffset*4));
      
      rGPMCON = uConValue;
       
   }
   else
   {
     Uart_Printf("GPIO_SetEINT_Group0:Error Eint No %d. \n",uEINT_No);
     return -1;
   }
   
   
   //˲ʽ
   
   // Check Filter Width 
	if(uFltWidth >=0x40)
	{
		Uart_Printf("GPIO_SetEINT_Group0:Error Filter Width %d. \n",uFltWidth);
		//Assert(0);
		return -1;
		
	}

	// Fliter Type & Filter Width 
	if( uEINT_No <= 7)
	{
		uOffset =(uEINT_No>>1);
		
		uConValue = rEINT0FLTCON0;
		//ÿٽŹһ,ÿ˲ռ8λ
		uConValue = (uConValue & ~(0xFF<<(uOffset*8))) |((uFltWidth<<(uOffset*8))|(eFltType<<(uOffset*8+6)));
		rEINT0FLTCON0 = uConValue;	
		
		
	}
	else if(uEINT_No >= 8  && uEINT_No <= 15)
	{
		uOffset =(uEINT_No>>1)-4;
		
		uConValue = rEINT0FLTCON1;
		uConValue = (uConValue & ~(0xFF<<(uOffset*8))) |((uFltWidth<<(uOffset*8))|(eFltType<<(uOffset*8+6)));
		
		rEINT0FLTCON1 = uConValue;	
	}
	else if(uEINT_No >= 16  && uEINT_No <= 23)
	{
		uOffset =(uEINT_No>>1)-8;
		
		uConValue = rEINT0FLTCON2;
		uConValue = (uConValue & ~(0xFF<<(uOffset*8))) |((uFltWidth<<(uOffset*8))|(eFltType<<(uOffset*8+6)));
		rEINT0FLTCON2 = uConValue;	
	}
	else if(uEINT_No >= 24  && uEINT_No <= 27)
	{
		uOffset =(uEINT_No>>1)-12;
		
		uConValue = rEINT0FLTCON3;
		uConValue = (uConValue & ~(0xFF<<(uOffset*8))) |((uFltWidth<<(uOffset*8))|(eFltType<<(uOffset*8+6)));
		rEINT0FLTCON3 = uConValue;	
	}


   return 0;
   
}

//GPIOжָʾ־,һISRִ
void EINT_Group0_ClrPend(unsigned int uEINT_No )
{
	
	rEINT0PEND  |= (1<<uEINT_No);
}

//رĳһж,жMaskĴ1.
void EINT_Group0_GPIO_Disable(unsigned int uEINT_No)
{
   rEINT0MASK |= (1<<uEINT_No);
}

//ĳһж,,жMaskĴ0
void EINT_Group0_GPIO_Enable(unsigned int uEINT_No)
{
   rEINT0MASK &=  ~(0x1<<(uEINT_No));
}

//һж
void INTC_SetSoftInt(unsigned int intNum)
{
  if(intNum > INT_LIMIT)
     {
        return ;
     }
     
   	if(intNum<32)
	{
		
		rVIC0SOFTINT |= (1<<intNum);
		
	}
	else
	{
	    rVIC1SOFTINT |= (1<<(intNum - 32));	    			
	}
}

//رFĳһж
void INTC_ClearSoftInt(unsigned int intNum)
{
  if(intNum > INT_LIMIT)
     {
        return ;
     }
     
   	if(intNum<32)
	{
		
		rVIC0SOFTINTCLEAR |= (1<<intNum);
		
	}
	else
	{
	    rVIC1SOFTINTCLEAR |= (1<<(intNum - 32));	    			
	}
}

//ȡirq״̬
unsigned int INTC_GetVicIrqStatus(unsigned int uController)
{
	if(uController == 0)
		return	rVIC0IRQSTATUS;
	else if(uController == 1)
		return 	rVIC1IRQSTATUS;

	return 0;
}

int INTC_SetPriority(unsigned int intNum,unsigned int level)
{
   if(intNum > INT_LIMIT )
     {
        return -1;
     }
     
    if(intNum < 32)
     {
       rVIC0VECPRIORITY = level & 0xF;
     }
     else
     {
        rVIC1VECPRIORITY = level & 0xF;
     }
     
     return 0;
}
















