#ifndef __INTERRUPT_H__
#define __INTERRUPT_H__

#ifdef __cplusplus
extern "C" {
#endif
#define MAX_INT_NUM 64


#define VIC0_BASE				(0x71200000)
#define VIC1_BASE				(0x71300000)


//interrupte register

// VIC0
#define	rVIC0IRQSTATUS			(*(volatile unsigned *)( VIC0_BASE + 0x00))
#define	rVIC0FIQSTATUS			(*(volatile unsigned *)( VIC0_BASE + 0x04))
#define	rVIC0RAWINTR			(*(volatile unsigned *)( VIC0_BASE + 0x08))
#define	rVIC0INTSELECT			(*(volatile unsigned *)( VIC0_BASE + 0x0c))
#define	rVIC0INTENABLE			(*(volatile unsigned *)( VIC0_BASE + 0x10))
#define	rVIC0INTENCLEAR			(*(volatile unsigned *)( VIC0_BASE + 0x14))
#define	rVIC0SOFTINT			(*(volatile unsigned *)( VIC0_BASE + 0x18))
#define	rVIC0SOFTINTCLEAR		(*(volatile unsigned *)( VIC0_BASE + 0x1c))
#define	rVIC0PROTECTION			(*(volatile unsigned *)( VIC0_BASE + 0x20))
#define	rVIC0SWPRIORITYMASK		(*(volatile unsigned *)( VIC0_BASE + 0x24))
#define	rVIC0PRIORITYDAISY		(*(volatile unsigned *)( VIC0_BASE + 0x28))

//עĿԿ׵ַrVIC0VECTADDR32λСָ
#define rVIC0VECTADDR			(*(volatile unsigned *)( VIC0_BASE + 0x100))



#define rVIC0VECPRIORITY		(*(volatile unsigned char *)( VIC0_BASE + 0x200))

#define rVIC0ADDR				(*(volatile unsigned *)( VIC0_BASE + 0xf00))
#define rVIC0PERID0				(*(volatile unsigned *)( VIC0_BASE + 0xfe0))
#define rVIC0PERID1				(*(volatile unsigned *)( VIC0_BASE + 0xfe4))
#define rVIC0PERID2				(*(volatile unsigned *)( VIC0_BASE + 0xfe8))
#define rVIC0PERID3				(*(volatile unsigned *)( VIC0_BASE + 0xfec))
#define rVIC0PCELLID0			(*(volatile unsigned *)( VIC0_BASE + 0xff0))
#define rVIC0PCELLID1			(*(volatile unsigned *)( VIC0_BASE + 0xff4))
#define rVIC0PCELLID2			(*(volatile unsigned *)( VIC0_BASE + 0xff8))
#define rVIC0PCELLID3			(*(volatile unsigned *)( VIC0_BASE + 0xffc))

// VIC1
#define	rVIC1IRQSTATUS			(*(volatile unsigned *)( VIC1_BASE + 0x00))
#define	rVIC1FIQSTATUS			(*(volatile unsigned *)( VIC1_BASE + 0x04))
#define	rVIC1RAWINTR			(*(volatile unsigned *)( VIC1_BASE + 0x08))
#define	rVIC1INTSELECT			(*(volatile unsigned *)( VIC1_BASE + 0x0c))
#define	rVIC1INTENABLE			(*(volatile unsigned *)( VIC1_BASE + 0x10))
#define	rVIC1INTENCLEAR			(*(volatile unsigned *)( VIC1_BASE + 0x14))
#define	rVIC1SOFTINT			(*(volatile unsigned *)( VIC1_BASE + 0x18))
#define	rVIC1SOFTINTCLEAR		(*(volatile unsigned *)( VIC1_BASE + 0x1c))
#define	rVIC1PROTECTION			(*(volatile unsigned *)( VIC1_BASE + 0x20))
#define	rVIC1SWPRIORITYMASK		(*(volatile unsigned *)( VIC1_BASE + 0x24))
#define	rVIC1PRIORITYDAISY		(*(volatile unsigned *)( VIC1_BASE + 0x28))

#define rVIC1VECTADDR			(*(volatile unsigned *)( VIC1_BASE + 0x100))



#define rVIC1VECPRIORITY		(*(volatile unsigned char*)( VIC1_BASE + 0x200))

#define rVIC1ADDR				(*(volatile unsigned *)( VIC1_BASE + 0xf00))
#define rVIC1PERID0				(*(volatile unsigned *)( VIC1_BASE + 0xfe0))
#define rVIC1PERID1				(*(volatile unsigned *)( VIC1_BASE + 0xfe4))
#define rVIC1PERID2				(*(volatile unsigned *)( VIC1_BASE + 0xfe8))
#define rVIC1PERID3				(*(volatile unsigned *)( VIC1_BASE + 0xfec))
#define rVIC1PCELLID0			(*(volatile unsigned *)( VIC1_BASE + 0xff0))
#define rVIC1PCELLID1			(*(volatile unsigned *)( VIC1_BASE + 0xff4))
#define rVIC1PCELLID2			(*(volatile unsigned *)( VIC1_BASE + 0xff8))
#define rVIC1PCELLID3			(*(volatile unsigned *)( VIC1_BASE + 0xffc))


#define VIC0VECTADDR             (( unsigned *)(0x71200100))
#define VIC1VECTADDR			 (( unsigned *)(0x71300100))


#define rEINT0CON0              (*(volatile unsigned *)(0x7F008900))
#define rEINT0CON1              (*(volatile unsigned *)(0x7F008904))

#define rEINT0FLTCON0           (*(volatile unsigned *)(0x7F008910))
#define rEINT0FLTCON1           (*(volatile unsigned *)(0x7F008914))
#define rEINT0FLTCON2           (*(volatile unsigned *)(0x7F008918))
#define rEINT0FLTCON3           (*(volatile unsigned *)(0x7F00891C))

#define rEINT0PEND              (*(volatile unsigned *)(0x7F008924))

#define rEINT0MASK              (*(volatile unsigned *)(0x7F008920))

//intterupt number
#define INT_LIMIT				(64)

//INT NUM - VIC0
#define INT_EINT0				(0)
#define INT_EINT1				(1)
#define INT_RTC_TIC				(2)
#define INT_CAMIF_C			    (3)
#define INT_CAMIF_P			    (4)
#define INT_I2C1				(5)
#define INT_I2S					(6)

#define INT_3D					(8)
#define INT_POST0				(9)
#define INT_ROTATOR			    (10)
#define INT_2D					(11)
#define INT_TVENC				(12)
#define INT_SCALER				(13)
#define INT_BATF				(14)
#define INT_JPEG				(15)
#define INT_MFC					(16)
#define INT_SDMA0				(17)
#define INT_SDMA1				(18)
#define INT_ARM_DMAERR		(19)
#define INT_ARM_DMA			(20)
#define INT_ARM_DMAS			(21)
#define INT_KEYPAD				(22)
#define INT_TIMER0				(23)
#define INT_TIMER1				(24)
#define INT_TIMER2				(25)
#define INT_WDT				(26)
#define INT_TIMER3				(27)
#define INT_TIMER4				(28)
#define INT_LCD0				(29)
#define INT_LCD1				(30)
#define INT_LCD2				(31)

//INT NUM - VIC1
#define INT_EINT2				(32+0)
#define INT_EINT3				(32+1)
#define INT_PCM0				(32+2)
#define INT_PCM1				(32+3)
#define INT_AC97				(32+4)
#define INT_UART0				(32+5)
#define INT_UART1				(32+6)
#define INT_UART2				(32+7)
#define INT_UART3				(32+8)
#define INT_DMA0				(32+9)
#define INT_DMA1				(32+10)
#define INT_ONENAND0			(32+11)
#define INT_ONENAND1			(32+12)
#define INT_NFC					(32+13)
#define INT_CFC					(32+14)
#define INT_UHOST				(32+15)
#define INT_SPI0				(32+16)
#define INT_SPI1				(32+17)
#define INT_I2C0				(32+18)
#define INT_HSItx				(32+19)
#define INT_HSIrx				(32+20)
#define INT_EINTGroup			(32+21)
#define INT_MSM				(32+22)
#define INT_HOSTIF				(32+23)
#define INT_HSMMC0				(32+24)
#define INT_HSMMC1				(32+25)
#define INT_OTG					(32+26)
#define INT_IRDA				(32+27)
#define INT_RTC_ALARM			(32+28)
#define INT_SEC					(32+29)
#define INT_PENDNUP				(32+30)
#define INT_ADC					(32+31)
#define INT_PMU					(32+32)



typedef enum INT_TYPE
{
	Trigger_Low		= (unsigned int) 0x0,
	Trigger_High	= (unsigned int) 0x1,
	Trigger_Falling	= (unsigned int) 0x2,
	Trigger_Rising	= (unsigned int) 0x4,
	Trigger_Both	= (unsigned int) 0x6
}INT_eTYPE;


typedef enum FLT_TYPE
{
	eDisFLT	= (unsigned int) 0x0,
	eEnFLT	= (unsigned int) 0x1, 		// EINT Group 1~9
	eDLYFLT	= (unsigned int) 0x2,		// 2'b10 => Filter Enable, Delay Filter
	eDIGFLT	= (unsigned int) 0x3
}FLT_eTYPE;

extern void INTC_Init(void) ;
extern int INTC_Enable(unsigned int intNum);
extern int INTC_Disable(unsigned int intNum);
extern int INTC_SetFIQ(unsigned int intNum);
extern int INTC_ReadIntSrc(void);
extern void INTC_ClearVectAddr(void);
extern void INTC_SetIntISR(unsigned int intNum, void (*isr)(void) __irq);

extern void INTC_SetSoftInt(unsigned int intNum);
extern void INTC_ClearSoftInt(unsigned int intNum);

extern int INTC_SetPriority(unsigned int intNum,unsigned int level);

extern int EINT_Group0_SetGPIO(unsigned int uEINT_No , INT_eTYPE uIntType, FLT_eTYPE eFltType,   unsigned int uFltWidth);
extern void EINT_Group0_ClrPend(unsigned int uEINT_No );
extern void EINT_Group0_GPIO_Disable(unsigned int uEINT_No);
extern void EINT_Group0_GPIO_Enable(unsigned int uEINT_No);
#ifdef __cplusplus
}
#endif
#endif /* __INTERRUPT_H__ */