#ifndef __S3C6410ADDR_H__
#define __S3C6410ADDR_H__

#ifdef __cplusplus
extern "C" {
#endif

// System Controller
#define SYSCON_BASE        (0x7E00F000)
#define rMEM_SYS_CFG    (*(volatile unsigned *)(SYSCON_BASE+0x120))

// GPIO
#define GPIO_BASE    (0x7F008000)
#define rGPACON        (*(volatile unsigned *)(GPIO_BASE+0x00))
#define rGPADAT        (*(volatile unsigned *)(GPIO_BASE+0x04))
#define rGPAPUD        (*(volatile unsigned *)(GPIO_BASE+0x08))
#define rGPBCON        (*(volatile unsigned *)(GPIO_BASE+0x20))
#define rGPBDAT        (*(volatile unsigned *)(GPIO_BASE+0x24))
#define rGPBPUD        (*(volatile unsigned *)(GPIO_BASE+0x28))
#define rGPNCON        (*(volatile unsigned *)(GPIO_BASE+0x830))
#define rGPNDAT        (*(volatile unsigned *)(GPIO_BASE+0x834))
#define rGPNPUD        (*(volatile unsigned *)(GPIO_BASE+0x838))

#define rGPECON         (*(volatile unsigned *)(0x7F008080)) 
#define rGPEDAT         (*(volatile unsigned *)(0x7F008084)) 
#define rGPEPUD         (*(volatile unsigned *)(0x7F008088)) 

#define rGPFCON         (*(volatile unsigned *)(0x7F0080A0))
#define rGPFDAT         (*(volatile unsigned *)(0x7F0080A4))
#define rGPFPUD         (*(volatile unsigned *)(0x7F0080A8))
#define rGPFECONSLP     (*(volatile unsigned *)(0x7F0080AC))
#define rGPFPUDSLP      (*(volatile unsigned *)(0x7F0080B0))


#define rGPLCON0        (*(volatile unsigned *)(0x7F008810))
#define rGPLCON1        (*(volatile unsigned *)(0x7F008814))
#define rGPLDAT         (*(volatile unsigned *)(0x7F008818))
#define rGPLPUD         (*(volatile unsigned *)(0x7F00881C))

#define rGPMCON          (*(volatile unsigned *)(0x7F008820))
#define rGPMDAT          (*(volatile unsigned *)(0x7F008824))
#define rGPMPUD          (*(volatile unsigned *)(0x7F008828))


/* PWM Timer */
#define rTCFG0       (*(volatile unsigned *)(0x7F006000))
#define rTCFG1 		 (*(volatile unsigned *)(0x7F006004))
#define rTCON 		 (*(volatile unsigned *)(0x7F006008))
#define rTCNTB0      (*(volatile unsigned *)(0x7F00600C))
#define rTCMPB0      (*(volatile unsigned *)(0x7F006010))
#define rTCNTO0      (*(volatile unsigned *)(0x7F006014))
#define rTCNTB1      (*(volatile unsigned *)(0x7F006018))
#define rTCMPB1      (*(volatile unsigned *)(0x7F00601c))
#define rTCNTO1      (*(volatile unsigned *)(0x7F006020))
#define rTCNTB2      (*(volatile unsigned *)(0x7F006024))
#define rTCNTO2      (*(volatile unsigned *)(0x7F00602c))
#define rTCNTB3      (*(volatile unsigned *)(0x7F006030))
#define rTCNTO3      (*(volatile unsigned *)(0x7F006038))
#define rTCNTB4      (*(volatile unsigned *)(0x7F00603c)) 
#define rTCNTO4      (*(volatile unsigned *)(0x7F006040)) 
#define rTINT_CSTAT  (*(volatile unsigned *)(0x7F006044))


#define rGPKCON0        (*(volatile unsigned *)(0x7F008800))
#define rGPKCON1        (*(volatile unsigned *)(0x7F008804))
#define rGPKDAT         (*(volatile unsigned *)(0x7F008808))
#define rGPKPUD         (*(volatile unsigned *)(0x7F00880C))


#define rGPJCON         (*(volatile unsigned *)(0x7F008120))
#define rGPJDAT         (*(volatile unsigned *)(0x7F008124))
#define rGPJPUD         (*(volatile unsigned *)(0x7F008128))


#define rGPICON         (*(volatile unsigned *)(0x7F008100))
#define rGPIDAT         (*(volatile unsigned *)(0x7F008104))
#define rGPIPUD         (*(volatile unsigned *)(0x7F008108))

// NAND Flash Controller
#define NANDF_BASE    (0x70200000)
#define rNFCONF        (*(volatile unsigned *)(NANDF_BASE+0x00))        //NAND Flash configuration
#define rNFCONT        (*(volatile unsigned *)(NANDF_BASE+0x04))          //NAND Flash control
#define rNFCMD        (*(volatile unsigned *)(NANDF_BASE+0x08))         //NAND Flash command
#define rNFADDR        (*(volatile unsigned *)(NANDF_BASE+0x0C))         //NAND Flash address
#define rNFDATA        (*(volatile unsigned *)(NANDF_BASE+0x10))          //NAND Flash data
#define rNFDATA8    (*(volatile unsigned char *)(NANDF_BASE+0x10))    //NAND Flash data (byte)
#define rNFDATA32    (*(volatile unsigned *)(NANDF_BASE+0x10))       //NAND Flash data (word)
#define NFDATA        (NANDF_BASE+0x10)
#define rNFMECCD0    (*(volatile unsigned *)(NANDF_BASE+0x14))          //NAND Flash ECC for Main
#define rNFMECCD1    (*(volatile unsigned *)(NANDF_BASE+0x18))          //NAND Flash ECC for Main
#define rNFSECCD    (*(volatile unsigned *)(NANDF_BASE+0x1C))          //NAND Flash ECC for Spare Area
#define rNFSBLK         (*(volatile unsigned *)(NANDF_BASE+0x20))        //NAND Flash programmable start block address
#define rNFEBLK         (*(volatile unsigned *)(NANDF_BASE+0x24))            //NAND Flash programmable end block address
#define rNFSTAT         (*(volatile unsigned *)(NANDF_BASE+0x28))          //NAND Flash operation status
#define rNFECCERR0    (*(volatile unsigned *)(NANDF_BASE+0x2C))          //NAND Flash ECC Error Status for I/O [7:0]
#define rNFECCERR1    (*(volatile unsigned *)(NANDF_BASE+0x30))          //NAND Flash ECC Error Status for I/O [15:8]
#define rNFMECC0    (*(volatile unsigned *)(NANDF_BASE+0x34))          //SLC or MLC NAND Flash ECC status
#define rNFMECC1    (*(volatile unsigned *)(NANDF_BASE+0x38))            //SLC or MLC NAND Flash ECC status
#define rNFSECC         (*(volatile unsigned *)(NANDF_BASE+0x3C))          //NAND Flash ECC for I/O[15:0]
#define rNFMLCBITPT    (*(volatile unsigned *)(NANDF_BASE+0x40))         //NAND Flash 4-bit ECC Error Pattern for data[7:0]

// UART
#define UART0_BASE    (0x7F005000)
#define rULCON0        (*(volatile unsigned *)(UART0_BASE+0x00))
#define rUCON0        (*(volatile unsigned *)(UART0_BASE+0x04))
#define rUFCON0        (*(volatile unsigned *)(UART0_BASE+0x08))
#define rUMCON0        (*(volatile unsigned *)(UART0_BASE+0x0C))
#define rUTRSTAT0     (*(volatile unsigned *)(UART0_BASE+0x10))
#define rUERSTAT0     (*(volatile unsigned *)(UART0_BASE+0x14))
#define rUFSTAT0    (*(volatile unsigned *)(UART0_BASE+0x18))
#define rUMSTAT0    (*(volatile unsigned *)(UART0_BASE+0x1C))
#define rUTXH0        (*(volatile unsigned *)(UART0_BASE+0x20))
#define rURXH0        (*(volatile unsigned *)(UART0_BASE+0x24))
#define rUBRDIV0        (*(volatile unsigned *)(UART0_BASE+0x28))
#define rUDIVSLOT0     (*(volatile unsigned *)(UART0_BASE+0x2C))
#define rUINTP0        (*(volatile unsigned *)(UART0_BASE+0x30))
#define rUINTSP0        (*(volatile unsigned *)(UART0_BASE+0x34))
#define rUINTM0        (*(volatile unsigned *)(UART0_BASE+0x38))

#define UART1_BASE    (0x7F005400)
#define rULCON1        (*(volatile unsigned *)(UART1_BASE+0x00))
#define rUCON1        (*(volatile unsigned *)(UART1_BASE+0x04))
#define rUFCON1        (*(volatile unsigned *)(UART1_BASE+0x08))
#define rUMCON1        (*(volatile unsigned *)(UART1_BASE+0x0C))
#define rUTRSTAT1     (*(volatile unsigned *)(UART1_BASE+0x10))
#define rUERSTAT1     (*(volatile unsigned *)(UART1_BASE+0x14))
#define rUFSTAT1    (*(volatile unsigned *)(UART1_BASE+0x18))
#define rUMSTAT1    (*(volatile unsigned *)(UART1_BASE+0x1C))
#define rUTXH1        (*(volatile unsigned *)(UART1_BASE+0x20))
#define rURXH1        (*(volatile unsigned *)(UART1_BASE+0x24))
#define rUBRDIV1        (*(volatile unsigned *)(UART1_BASE+0x28))
#define rUDIVSLOT1     (*(volatile unsigned *)(UART1_BASE+0x2C))
#define rUINTP1        (*(volatile unsigned *)(UART1_BASE+0x2C))
#define rUINTSP1        (*(volatile unsigned *)(UART1_BASE+0x34))
#define rUINTM1        (*(volatile unsigned *)(UART1_BASE+0x38))

#define UART2_BASE    (0x7F005800)
#define rULCON2        (*(volatile unsigned *)(UART2_BASE+0x00))
#define rUCON2         (*(volatile unsigned *)(UART2_BASE+0x04))
#define rUFCON2        (*(volatile unsigned *)(UART2_BASE+0x08))
#define rUMCON2        (*(volatile unsigned *)(UART2_BASE+0x0C))
#define rUTRSTAT2     (*(volatile unsigned *)(UART2_BASE+0x10))
#define rUERSTAT2     (*(volatile unsigned *)(UART2_BASE+0x14))
#define rUFSTAT2      (*(volatile unsigned *)(UART2_BASE+0x18))
#define rUMSTAT2      (*(volatile unsigned *)(UART2_BASE+0x1C))
#define rUTXH2        (*(volatile unsigned *)(UART2_BASE+0x20))
#define rURXH2        (*(volatile unsigned *)(UART2_BASE+0x24))
#define rUBRDIV2        (*(volatile unsigned *)(UART2_BASE+0x28))
#define rUDIVSLOT2     (*(volatile unsigned *)(UART2_BASE+0x2C))
#define rUINTP2        (*(volatile unsigned *)(UART2_BASE+0x30))
#define rUINTSP2        (*(volatile unsigned *)(UART2_BASE+0x34))
#define rUINTM2        (*(volatile unsigned *)(UART2_BASE+0x38))


#define rADCCON       (*(volatile unsigned *)0x7E00B000)
#define rADCDAT0      (*(volatile unsigned short*)0x7E00B00C) 
#define rADCDAT1      (*(volatile unsigned short*)0x7E00B010)


#define rWTCON         (*(volatile unsigned short*)(0x7E004000))
#define rWTDAT         (*(volatile unsigned short*)(0x7E004004))
#define rWTCNT         (*(volatile unsigned short*)(0x7E004008))
#define rWTCLRINT      (*(volatile unsigned short*)(0x7E00400C))





void Uart_Init(void);
void Uart_SendByte(int data);
void Uart_SendString(char *pt);
void Uart_SendDWORD(unsigned int d, int cr);
char *hex2char(unsigned int val);

#define WrUTXH0(ch)     (*(volatile unsigned char *)(UART0_BASE+0x20))=(unsigned char)(ch)
#define RdURXH0()       (*(volatile unsigned char *)(UART0_BASE+0x24))
#define WrUTXH1(ch)     (*(volatile unsigned char *)(UART1_BASE+0x20))=(unsigned char)(ch)
#define RdURXH1()       (*(volatile unsigned char *)(UART1_BASE+0x24))
#define WrUTXH2(ch)     (*(volatile unsigned char *)(UART2_BASE+0x20))=(unsigned char)(ch)
#define RdURXH2()       (*(volatile unsigned char *)(UART2_BASE+0x24))

//--------------I2C ģ-----------------------
#define rIICCON0   (*(volatile unsigned char *)(0x7F004000))
#define rIICCON1   (*(volatile unsigned char *)(0x7F00F000))

#define rIICSTAT0  (*(volatile unsigned char *)(0x7F004004))
#define rIICSTAT1  (*(volatile unsigned char *)(0x7F00F004))

#define rIICADD0   (*(volatile unsigned char *)(0x7F004008))
#define rIICADD1   (*(volatile unsigned char *)(0x7F00F008))


#define rIICADD0   (*(volatile unsigned char *)(0x7F004008))
#define rIICADD1   (*(volatile unsigned char *)(0x7F00F008))

#define rIICDS0    (*(volatile unsigned char *)(0x7F00400C))
#define rIICDS1    (*(volatile unsigned char *)(0x7F00F00C))

#define rIICLC0    (*(volatile unsigned char *)(0x7F004010))
#define rIICLC1    (*(volatile unsigned char *)(0x7F00F010))

#if 1
//---------------- mode if ---------------------
#define rMIFPCON  (*(volatile unsigned char *)(0x7410800C))

//------------- LCD Module--------------------------------

#define rSPCON (*(volatile unsigned *)0x7F0081A0)  

#define rVIDCON0 (*(volatile unsigned *)0x77100000) 
#define rVIDCON1 (*(volatile unsigned *)0x77100004) 
#define rVIDCON2 (*(volatile unsigned *)0x77100008) 


#define rVIDTCON0 (*(volatile unsigned *)0x77100010) 
#define rVIDTCON1 (*(volatile unsigned *)0x77100014)
#define rVIDTCON2 (*(volatile unsigned *)0x77100018)

#define rWINCON0 (*(volatile unsigned *)0x77100020)
#define rWINCON1 (*(volatile unsigned *)0x77100024)
#define rWINCON2 (*(volatile unsigned *)0x77100028)
#define rWINCON3 (*(volatile unsigned *)0x7710002C)
#define rWINCON4 (*(volatile unsigned *)0x77100030)


#define WINCON ((volatile unsigned *)0x77100020)

#define rVIDW00ADD0B0 (*(volatile unsigned *)0x771000A0) 
#define rVIDW00ADD0B1 (*(volatile unsigned *)0x771000A4)
#define rVIDW01ADD0B0 (*(volatile unsigned *)0x771000A8) 
#define rVIDW01ADD0B1 (*(volatile unsigned *)0x771000AC)

#define rVIDW02ADD0   (*(volatile unsigned *)0x771000B0) 
#define rVIDW03ADD0   (*(volatile unsigned *)0x771000B8) 
#define rVIDW04ADD0   (*(volatile unsigned *)0x771000C0)
#define rVIDW00ADD1B0 (*(volatile unsigned *)0x771000D0)
#define rVIDW00ADD1B1 (*(volatile unsigned *)0x771000D4)
#define rVIDW01ADD1B0 (*(volatile unsigned *)0x771000D8)  
#define rVIDW01ADD1B1 (*(volatile unsigned *)0x771000DC)
#define rVIDW02ADD1   (*(volatile unsigned *)0x771000E0)
#define rVIDW03ADD1   (*(volatile unsigned *)0x771000E8)   
#define rVIDW04ADD1   (*(volatile unsigned *)0x771000F0)
#define rVIDW00ADD2   (*(volatile unsigned *)0x77100100)
#define rVIDW01ADD2   (*(volatile unsigned *)0x77100104)
#define rVIDW02ADD2   (*(volatile unsigned *)0x77100108)
#define rVIDW03ADD2   (*(volatile unsigned *)0x7710010C)
#define rVIDW04ADD2   (*(volatile unsigned *)0x77100110)


#define VIDOSDA        ((volatile unsigned *)0x77100040)

#define rVIDOSD0A      (*(volatile unsigned *)0x77100040) 
#define rVIDOSD0B      (*(volatile unsigned *)0x77100044)
#define rVIDOSD0C      (*(volatile unsigned *)0x77100048)

#define rVIDOSD1A      (*(volatile unsigned *)0x77100050) 
#define rVIDOSD1B      (*(volatile unsigned *)0x77100054)
#define rVIDOSD1C      (*(volatile unsigned *)0x77100058)
#define rVIDOSD1D      (*(volatile unsigned *)0x7710005C)

#define rVIDOSD2A      (*(volatile unsigned *)0x77100060) 
#define rVIDOSD2B      (*(volatile unsigned *)0x77100064)
#define rVIDOSD2C      (*(volatile unsigned *)0x77100068)
#define rVIDOSD2D      (*(volatile unsigned *)0x7710006C)

#define rVIDOSD3A      (*(volatile unsigned *)0x77100070) 
#define rVIDOSD3B      (*(volatile unsigned *)0x77100074)
#define rVIDOSD3C      (*(volatile unsigned *)0x77100078)

#define rVIDOSD4A      (*(volatile unsigned *)0x77100080) 
#define rVIDOSD4B      (*(volatile unsigned *)0x77100084)
#define rVIDOSD4C      (*(volatile unsigned *)0x77100088) 

#endif 

#ifdef __cplusplus
}
#endif
#endif  //__S3C6410ADDR_H__

