#include "s3c6410_addr.h"
#include "utils.h"
#include "soc_cfg.h"
#include "defs.h"

#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#if 1
//ѯĶʱʵ־ȷʱ
//΢Ϊλ
void Delay(int time) 
{
	unsigned int val = (PCLK>>3)/1000-1;
	
	rTCFG0 &= ~(0xff<<8);
	rTCFG0 |= 3<<8;			//prescaler = 3+1
	rTCFG1 &= ~(0xf<<12);
	rTCFG1 |= 0<<12;		//mux = 1/2

	rTCNTB3 = val;
	//rTCMPB3 = val>>1;		// 50%
	rTCON &= ~(0xf<<16);
	rTCON |= 0xb<<16;		//interval, inv-off, update TCNTB3&TCMPB3, start timer 3
	rTCON &= ~(2<<16);		//clear manual update bit
	while(time--) {
		while(rTCNTO3>=val>>1);
		while(rTCNTO3<val>>1);
	};
}
#else
void Delay(int time)
{
    	volatile unsigned int k;
    	for(k = 0; k < 2000000; k++);
}
#endif

//ȷusʱ,ʹTimer2 
void uDelay(int usec)
{
  unsigned int val = (PCLK)/1000000-1;
  //timer 2 prscaler = 0;
  rTCFG0 &= ~(0xff<<8);
  rTCFG0 |= 0<<8;			//prescaler = 0+1
  
  //timer 2 MUX 
  rTCFG1 &= ~(0xf<<8);
  
  
  rTCFG1 |= 0<<8;		//mux = 1/1
  
  rTCNTB2 = val;
  
  	rTCON &= ~(0xf<<12);
	rTCON |= 0xb<<12;		//interval, inv-off, update TCNTB3&TCMPB3, start timer 3
	rTCON &= ~(2<<12);		//clear manual update bit
	while(usec--) {
		while(rTCNTO2>=val>>1);
		while(rTCNTO2<val>>1);
	};
  
}
 

void Port_Init(void)
{
    rGPKCON0 = (rGPKCON0 & ~(0xffffU<<16))|(0x1111U<<16);
    rGPKPUD  = (rGPKPUD  & ~(0xffU << 8))|(0x00U<<8);
}

void Led_Display(int data)
{
    rGPKDAT = (rGPKDAT & ~(0xf<<4)) | ((data & 0xf)<<4);
}



//1Ϊʼ,1,2,3,4
void Led_On(int id)
{
    rGPKDAT &=~(1<<(id+3));
}

void Led_Off(int id)
{
    rGPKDAT |=(1 << (id+3));
}

void Led_AllOff(void)
{
  rGPKDAT |= (0xF << 4);
}

void Led(int id,int on)
{
  if(on)
    Led_On(id);
  else
    Led_Off(id);  
}

//ͬʱ趨,Ӧ1ʾ,Ϊ0ʾϨ
void Leds(unsigned int val)
{
   rGPKDAT &= ~(0xF << 4); //,ֹvalе㲻Ч
   rGPKDAT |=  ((~val) << 4);
}


void Uart_Init(void)
{
    // UART I/O port initialize (RXD0 : GPA0, TXD0: GPA1)
    rGPACON = (rGPACON & ~(0xff<<0)) | (0x22<<0);    // GPA0->RXD0, GPA1->TXD0
    rGPAPUD = (rGPAPUD & ~(0xf<<0)) | (0x1<<0);        // RXD0: Pull-down, TXD0: pull up/down disable

    // Initialize UART Ch0
    rULCON0 = (0<<6)|(0<<3)|(0<<2)|(3<<0);                    // Normal Mode, No Parity, 1 Stop Bit, 8 Bit Data
    rUCON0 = (0<<10)|(1<<9)|(1<<8)|(0<<7)|(0<<6)|(0<<5)|(0<<4)|(1<<2)|(1<<0);    // PCLK divide, Polling Mode
    rUFCON0 = (0<<6)|(0<<4)|(0<<2)|(0<<1)|(0<<0);            // Disable FIFO
    rUMCON0 = (0<<5)|(0<<4)|(0<<0);                        // Disable Auto Flow Control

    rUBRDIV0 = 35;                                    // Baud rate
    rUDIVSLOT0 = 0x80;//aSlotTable[DivSlot];
}


void Uart_SendByte(int data)
{
    while(!(rUTRSTAT0 & 0x2));   //Wait until THR is empty.
    //_Delay();
    WrUTXH0(data);
}

void Uart_SendString(char *pt)
{
    while(*pt)
        Uart_SendByte(*pt++);
}

//=====================================================================
char Uart_GetCh(void)
{
         
     while(!(rUTRSTAT0 & 0x1)); //Receive data ready
        return RdURXH0();
   
}

char Uart_GetKey(void)
{
        if(rUTRSTAT0 & 0x1)    //Receive data ready
            return RdURXH0();
        return 0;    
}




//=====================================================================
#if 1
//If you don't use vsprintf(), the code size is reduced very much.
void Uart_Printf(char *fmt,...)
{
    va_list ap;
    char string[256];

    va_start(ap,fmt);
    vsprintf(string,fmt,ap);
    Uart_SendString(string);
    va_end(ap);
}

#endif
